include '%lib%/freshlib.inc'

@BinaryType GUI, default

uses kernel32, user32, gdi32;, comctl32, comdlg32, ole32

LIB_MODE  equ OLD

options.DebugMode = 0
options.ShowSkipped = 0
options.FastEnter = 0
options.CheckArguments = 0
options.ShowSizes = 0
options.DisableMMX = 0

include "%lib%/freshlib.asm"

;include '%finc%/win32/win32a.inc'

include "%finc%/libs/msgutils.inc"
include "%finc%/libs/tform.inc"
include "%finc%/libs/parents.inc"
include "%finc%/libs/templates.inc"

include "%finc%/libs/msgutils.asm"
include "%finc%/libs/tform.asm"
include "%finc%/libs/parents.asm"
include "%finc%/libs/templates.asm"
include "%finc%/libs/gui.asm"

include "MainForm.frm"

uglobal
  hInstance dd ?
  hHeap     dd ?
  hMainForm dd ?
endg

start:
        invoke  GetModuleHandleA,0
        mov     [hInstance],eax
        invoke  GetProcessHeap
        mov     [hHeap], eax

        InitializeAll

        stdcall CreateForm, frmMain, NULL
        xor     eax, eax
        test    ebx, ebx
        jz      .terminate

        mov     [hMainForm], ebx

.run:
        call    ProcessMessages
        jc      .terminate

        invoke  WaitMessage
        jmp     .run

.terminate:
        push    eax
        FinalizeAll
        invoke  ExitProcess ; exit code from the stack.
